#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "asaxlib.h" 

#define	S_IGID(m)	((((m)& 0017000) == S_ISUID) || \
                         (((m)& 0017000) == S_ISGID) || \
                         (((m)& 0017000) == (S_ISUID | S_ISGID)))

typedef void *hole;

void *isSUID(m)
char *m;
{
	hole **sp1;
	char *getExtStrRepr(), *s, *s1, *s2;
	char *path;
	struct stat buf;
	int mode;

	s = s1 = tmalloc(512, char);
  	sp1 = (hole **) m++; 
  	strcpy(s1, getExtStrRepr(*sp1++));
	s2 = getExtStrRepr(*sp1);
	while (*s1 != ' ')
		s1++;
	if (*s2 != '/') *s1++ = '/';
	while (*s2 != ' ') {
		*s1 = *s2;
		s1++;
		s2++;
	}
	*s1 = '\0';
	stat(s,  &buf);  
	mode = S_IGID(buf.st_mode);
	return((void *) mode);
}

#include <time.h>

/* void *gettime(m)
char *m;
{
        char *ctime(), buf[30], *s, *se;
        time_t *clock;
        unsigned short *sh;
        char **sp;

        struct tm *loc_tm, *localtime();
        static char fmt[19] = "%a %h %d %T %Y"; 

        sp = (char **) m;
        sh = (unsigned short *) *sp;
        clock = (time_t *) ++sh; 
        loc_tm = localtime((time_t *) clock);
        strftime(buf, 30, fmt, loc_tm);
        s = buf;
        se = tmalloc(strlen(s)+sizeof(unsigned short), char);
        sh = (unsigned short *) se;
        *sh = (unsigned short) strlen(s);
        strcpy(se + sizeof(unsigned short), s); 
        return( (void *) se ); 

}
	
*/
#include "nadf.tab.sun.h"

#define ALIGN_REC 4


/* */

void *display_sun(m)
char *m;
{
    display_sun1(Curr_Rec_Addr);
    printf("\n");
}
display_sun1(rec_addr)
char *rec_addr;
{
    int nb;
    short len;
    short id;
    int  type;
    int i;
    int j;
    int k;
    unsigned char *pa, c;
    char  buf[255];
    char  *rec_cur_ptr;
    int   *rec_len_ptr;
    short *shp, *rec_sht_ptr;
    long int *rec_longInt_ptr;
    char  *ctime(), *pstr, *pstr1;

	    rec_len_ptr = (int *) rec_addr;
	    rec_cur_ptr = rec_addr+4;
            nb = *rec_len_ptr-4;
            while (nb >0)
                {
                shp = rec_sht_ptr = (short *) rec_cur_ptr;
                id = *rec_sht_ptr;
		if (14 <= id && id <= 17) {
		  len = *++shp;
                  nb = nb-4-len-(len*(ALIGN_REC -1)%ALIGN_REC);
                  rec_cur_ptr += 4+len+(len*(ALIGN_REC -1)%ALIGN_REC); 
		  continue;
		}
		printf("\n");
		printf("%s[", nadf_tab[id].ndata_name);
                type = nadf_tab[id].ndata_typ;

		printf("%-4d, ", id);
                rec_sht_ptr++;
                len = *rec_sht_ptr;
		printf("%-2d] = ", len);
                nb = nb-4-len-(len*(ALIGN_REC -1)%ALIGN_REC);
                rec_cur_ptr = rec_cur_ptr+4;
                switch(type) {
                  
		  case tshort :
		  case tint   :
		  case tlong  :
		  case tunsignedint :
		  case tunsignedshort :

                    switch(len) {
                        case 1:
                        case 2:  rec_sht_ptr = (short *) rec_cur_ptr;
				 printf("%d",*rec_sht_ptr);
                                 break;
                        case 4:  rec_len_ptr = (int *) rec_cur_ptr;
				 if (id == 2 || id == 5 || id == 122) {
					pstr = malloc(24);
					pstr1 = ctime((long *) rec_cur_ptr);
					copy_bytes(pstr1,pstr,24);
				        printf("%s", pstr);
					free(pstr);
				 } else {
                                        printf("%d",*rec_len_ptr);
                                 }
                                 break;
			case 8:  rec_longInt_ptr = (long int *) rec_cur_ptr;
				 printf("%ld",*rec_len_ptr);
                                 break;
		       default:
				 printf("integer with len <> 2, 4, 8 " );
				 break;
                                 }
                    break;

		        case tstr    :

                     copy_bytes(rec_cur_ptr,buf,len);
                     buf[len]='\0';
		     printf("%s",buf);
                     break;

			default:

		     pa = (unsigned char *) rec_cur_ptr;
                     i = 1;
                     while ( i <= len )
                     {
                      j = 1;
                      while  ( (j <= 5) && (i <= len) )
                      {
                         k = 1;
                         while ( (k <=4) && (i <=len) )
                          {
			   c = (unsigned char) *pa;
			   if (c < 10)
			       printf("0%x",*pa);
			   else
			       printf("%x", *pa);
                           pa++;
                           i++;
                           k++;
                           }
                         j++;
                      }
		      printf("");

                     }
                     break;



                             } /* end switch type */

                rec_cur_ptr = rec_cur_ptr+len+(len*(ALIGN_REC -1)%ALIGN_REC);
		printf("  ");
                }
    }
